;********************************************************************
;                         Tomasz Jaboski                          *
;                 Mikrokontrolery PIC16F8x w praktyce               *
;                      Wydawnictwo BTC, www.btc.pl                  *
;********************************************************************

;wywietlanie cyfr 123 na wywietlaczu LED skadajcym
;si z 3 cyfr - rysunek 8.13
#include 16f84.h
b_wys		equ 0ch		;poczatek bufora wyswietlacza
nr_wys		equ 0fh		;biecy numer wywietlacza
w_temp		equ 10h		;rejestr zachowania W
st_temp		equ 11h		;rejestr zachowania STATUS
temp_porta	equ 12h		;rejestr pomocniczy porta

		org 0
		goto start

		org 0004
_int		movwf w_temp	;w_temp <- w
		swapf status,w	;w <-status
		movwf st_temp	;st_temp <-w
		bcf RP0		;bank0		

		bcf T0IF  	;zeruj flage przerwania od t0
		movlw 0xb1	;laduj t0
		movwf tmr0

		;obsuga wywietlacza
		incf nr_wys,f	;nast. cyfra
		movf nr_wys,w	;nr_wys do W
		xorlw 0x03	;czy rowne 3
		btfsc Z	 	;pomin zerowanie gdy z=0
		clrf nr_wys	;zeruj nr_wys
		
		movf temp_porta,w;wyzerowanie a0-a2
		andlw 0xf8
		movwf temp_porta		
		movf nr_wys,w	
		call _poz	;kombinacja bitw na a0..a2 zalenie od numeru wyswietlacza	
		iorwf temp_porta,f ;w=w or temp_porta		

		movlw b_wys	;poczatek bufora wywietlacza
		addwf nr_wys,w	;W=b_wys+nr_wys
		movwf fsr	;pointer
		movf indf,w	;czytaj ram (do W)
		movwf portb	;wyslij na portb

		movf temp_porta,w;na porta numer wywietlacza
		movwf porta
		;odtworzenie rejestrw W i status
		swapf st_temp,w	;w <- st_temp
		movwf status	;status <- w
		swapf w_temp,f
		swapf w_temp,w	;w <- w_temp
		
		retfie

_poz		addwf pcl,f
		dt 6,5,3

start		bcf RP0		;bank 0
		clrf porta
		clrf portb
		bsf RP0		;bank1
		bcf T0CS	;fxtal/4
		bcf PSA		;preskaler do t0
		bcf PS0		;preskaler 1/32
		bcf PS1
		bsf PS2

		movlw 0f0h
		movwf trisb
		clrf trisa
		bcf RP0		;bank0
		call _int
		movlw 0ffh
		movwf porta
		movwf portb
		movwf temp_porta
		
		clrf intcon
		movlw 0b1h	;adowanie licznika
		movwf tmr0

		bsf T0IE	;maska przerwania od licznika T0
		bsf GIE		;odblokowanie przerwa

		call _wyswietlanie ; wpisanie kodow cyfr do bufora wywietlacza
_et		nop		;petla nieskonczona - tylko wyswietlanie cyfr
		goto _et
		sleep

_wyswietlanie	movlw b_wys	;poczatek bufora wywietlacza
		movwf fsr
		movlw 1		;najstarsza cyfra
		movwf indf

		incf fsr,f
		movlw 2		;rodkowa cyfra
		movwf indf

		incf fsr,f
		movlw 3		;najmodsza cyfra
		movwf indf
		
		return
		
		end
